EP_AddPastureExtension = {}
local EP_AddPastureExtension_mt = Class(EP_AddPastureExtension, Event)

InitEventClass(EP_AddPastureExtension, 'EP_AddPastureExtension')

function EP_AddPastureExtension.emptyNew()
    return Event.new(EP_AddPastureExtension_mt)
end

function EP_AddPastureExtension.new(pastureExtension, pastureSystemId)
    local self = EP_AddPastureExtension.emptyNew()
    self.pastureExtension = pastureExtension
    self.pastureSystemId = pastureSystemId
    return self
end

function EP_AddPastureExtension:readStream(streamId, connection)
    self.pastureExtension = NetworkUtil.readNodeObject(streamId)
    self.pastureSystemId = streamReadString(streamId)
    self:run(connection)
end

function EP_AddPastureExtension:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.pastureExtension)
    streamWriteString(streamId, self.pastureSystemId)
end

function EP_AddPastureExtension:run(connection)
    local pastureSystem = g_currentMission.pastureSystem
    pastureSystem:addPastureExtension(self.pastureExtension, self.pastureSystemId)

    if not connection:getIsServer() then
        g_server:broadcastEvent(EP_AddPastureExtension.new(self.pastureExtension, self.pastureSystemId), false, connection)
    end
end